package projekt.enigma.model;

/**
 * Klasse Reflektor
 * <br>
 * Der Reflektor nimmt einen Buchstaben der Klasse Walze entgegen und codiert diesen.
 * Der codierte Buchstabe wird an die Klasse Walze wieder zurueckgegeben.
 * <br>
 * Prinzipiell verhaelt sich die Klasse Reflektor wie die Klasse Walze, ausser das sie sich
 * nach Betaetigung einer Taste nicht dreht (quasi starr montiert ist) und sie gibt keine Signale
 * an andere Walzen zum Drehen.
 */
public class Reflektor {

    /**
     * Funktion codiere
     * <br>
     * Durchsucht den String alphabet nach der Position des mitgegebenen Buchstabens und
     * gibt den Character an der entsprechenden Position im String reflektor zurueck.
     *
     * @param buchstabe : Character : der zu codierende Buchstabe.
     * @return char : Der codierte Buchstabe aus dem Reflektor.
     */
    public char codiere(Character buchstabe) {
        String alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        String reflektor = "EJMZALYXVBWFCRQUONTSPIKHGD";

        return reflektor.charAt(alphabet.indexOf(buchstabe));
    }
}
