package projekt.enigma.model;

import org.junit.Assert;
import org.junit.Test;

public class HardwareTest {

	@Test
	public void tippeBuchstabe() {

		Hardware h = new Hardware();
		h.setReflektor(new Reflektor());
		h.setSteckbrett(new Steckbrett());

		/*
        Walze nach der Chiffrierung
        Alphabet    "A B C D E F G H I J K L M N O P Q R S T U V W X Y Z"
        Steckbrett  "W S L V H Y G I X A"
        Steckbrett  "J E F B K P M Q U C"

		Walze 3   "E K M F L G D Q V Z N T O W Y H X U S P A I B R C J"
        Walze 2     "V Z B R G I T Y U P S D N H L X A W M J Q O F E C K"
        Walze 1   	"A J D K S I R U X B L H W T M C Q G Z N P Y F V O E"
        Reflektor   "E J M Z A L Y X V B W F C R Q U O N T S P I K H G D"
		*/

		char result;
		h.setWalzen(0, 2, 25);
		h.setWalzen(1, 5, 25);
		h.setWalzen(2, 1, 25);
		result = h.codiere('A');
		Assert.assertEquals("Codiere: A Erwartet N, erhalten " + result, 'N', result);
		result = h.codiere('B');
		Assert.assertEquals("Codiere: B Erwartet K, erhalten " + result, 'K', result);
		result = h.codiere('I');
		Assert.assertEquals("Codiere: I Erwartet V, erhalten " + result, 'V', result);
		result = h.codiere('F');
		Assert.assertEquals("Codiere: F Erwartet T, erhalten " + result, 'T', result);

		h.setWalzen(0, 2, 25);
		h.setWalzen(1, 5, 25);
		h.setWalzen(2, 1, 25);
		result = h.codiere('N');
		Assert.assertEquals("Decodiere: N Erwartet A, erhalten " + result, 'A', result);
		result = h.codiere('K');
		Assert.assertEquals("Decodiere: K Erwartet B, erhalten " + result, 'B', result);
		result = h.codiere('V');
		Assert.assertEquals("Decodiere: V Erwartet I, erhalten " + result, 'I', result);
		result = h.codiere('T');
		Assert.assertEquals("Decodiere: T Erwartet F, erhalten " + result, 'F', result);

		h.setWalzen(0, 2, 25);
		h.setWalzen(1, 5, 25);
		h.setWalzen(2, 1, 25);
		h.getSteckbrett().setzeVertauschung('B', 'G');
		h.getSteckbrett().setzeVertauschung('D', 'F');
		h.getSteckbrett().setzeVertauschung('I', 'L');
		h.getSteckbrett().setzeVertauschung('M', 'Q');
		h.getSteckbrett().setzeVertauschung('N', 'X');
		h.getSteckbrett().setzeVertauschung('K', 'Y');
		h.getSteckbrett().setzeVertauschung('U', 'Z');
		h.getSteckbrett().setzeVertauschung('A', 'O');
		h.getSteckbrett().setzeVertauschung('E', 'S');

		result = h.codiere('I');
		Assert.assertEquals("Codiere: I Erwartet C, erhalten " + result, 'C', result);

		h.setWalzen(0, 2, 25);
		h.setWalzen(1, 5, 25);
		h.setWalzen(2, 1, 25);
		result = h.codiere('C');
		Assert.assertEquals("Codiere: C Erwartet I, erhalten " + result, 'I', result);

		h.setWalzen(0, 2, 25);
		h.setWalzen(1, 5, 25);
		h.setWalzen(2, 1, 25);
		h.getSteckbrett().setzeVertauschung('A', 'B');
		h.getSteckbrett().setzeVertauschung('C', 'D');
		result = h.codiere('A');
		Assert.assertEquals("Codiere: A Erwartet M, erhalten " + result, 'M', result);
	}
}